#include "BlockMatching.h"
#include "CeilingMap.h"
#ifdef _DEBUG
#ifdef WIN32
#include <crtdbg.h>
#endif
#endif

#ifdef _USE_SHOW_MAP
#include "Common/sharedmem.h"
extern robot_status *rstat;
#endif

#define SEARCH_RANGE	4
#define SIZE_HALF	(block_size / 2) //W[ԋʂ̒lDƂׂ
#define ANGLE_MAX	(m_Resolution * 2 + 1)

/**
 *@brief RXgN^
 */
BlockMatching::BlockMatching(void) : m_BlockTable(0)
{
}

/**
 *@brief fXgN^
 *@note 摜̉]Eke[üj
 */
BlockMatching::~BlockMatching(void)
{
	if(m_BlockTable != 0)
		DeleteBlockTable();
}

/**
 * @brief ]Ekz쐬
 * @param center_x 摜]SXWB-1̏ꍇ͉摜̒SgpB(ftHg-1)
 * @param center_y 摜]SYWB-1̏ꍇ͉摜̒SgpB(ftHg-1)
 * @param image_width ͉摜
 * @param image_height ͉摜
 * @param block_size ŏIIȉ摜TCY(cETCY)
 * @param Coefficient 摜kpW
 * @param Resolution ]\(x݂ŉ]摜𐶐邩)
 * @param BlackWhiteValue 2l臒l
 *
 */
void BlockMatching::CreateBlockMap(const long center_x,
						   const long center_y,
						   const unsigned long image_width,
						   const unsigned long image_height,
						   const unsigned short block_size,
						   const double Coefficient,
						   const unsigned short Resolution,
						   const unsigned short BlackWhiteValue)
{
	int		i;
	int		x,	y;
	int		x2,	y2;
	int		sx,	sy;
	int		degree_min, degree_max;
	double	cx,	cy, dx1, dy1;
	unsigned long width, height;

	/*
		S_`ĂȂꍇ͉摜f[^̒S_̗p
		(ŏIIȒSWƂ邽1/4TCY̒Sɂ)
	*/

	width = image_width / 2;
	if(center_x == -1)
		cx = width / 2;
	else
		cx = center_x;	/* JZ^[ݒ */

	height = image_height / 2;
	if(center_y == -1)
		cy = height / 2;
	else
		cy = center_y;	/* JZ^[ݒ */

	sx = cx - (int)((double)SIZE_HALF / Coefficient);
	sy = cy - (int)((double)SIZE_HALF / Coefficient);

	m_Resolution = 360 / 2 / Resolution;
	degree_max = m_Resolution; //]p̃CfbNX̐(̕)
	degree_min = m_Resolution * -1;//]p̃CfbNX̐(̕)

	m_LatticeSize	= block_size;
	m_BlackWhiteValue = BlackWhiteValue;

	CreateBlockTable();

	for (y = 0; y < block_size; y++){
		for (x = 0; x < block_size; x++){
			for (i = degree_min; i <= degree_max; i++){
				x2 = sx + ( (double)((double)( x - SIZE_HALF )) * cos((double)i * M_PI / (double)m_Resolution) - 
							(double)((double)( y - SIZE_HALF )) * sin((double)i * M_PI / (double)m_Resolution) + (double)SIZE_HALF ) / Coefficient;

				y2 = sy + ( (double)((double)( x - SIZE_HALF )) * sin((double)i * M_PI / (double)m_Resolution) +
							(double)((double)( y - SIZE_HALF )) * cos((double)i * M_PI / (double)m_Resolution) + (double)SIZE_HALF ) / Coefficient;

/*				/\* UWɕϊɂĂłȂ... *\/ */

				dx1 = x2;
				dy1 = y2;

				if (dx1 <   0 )			  dx1 = 0;
				if (dx1 > (width - 1) )	  dx1 = (width - 1);
				if (dy1 <   0 )			{ dy1 = 0;					dx1=0; }
				if (dy1 > (height - 1) ){ dy1 = (height - 1); dx1=0; }

				m_BlockTable[ i + m_Resolution][x][y] = (int)((int)dx1 + (int)dy1 * (image_width / 2));
			}
		}
	}
}

/**
 *@brief CreateBlockMapblock_sizedeResolutionŎw肳ꂽ傫̔z𐶐B
 */
void BlockMatching::CreateBlockTable()
{
	m_BlockTable = new long**[ANGLE_MAX];
	for(int cnt_z = 0; cnt_z < ANGLE_MAX ; cnt_z++){
		m_BlockTable[cnt_z] = new long*[m_LatticeSize];
		for(int cnt_x_y = 0; cnt_x_y < m_LatticeSize; cnt_x_y++){
			m_BlockTable[cnt_z][cnt_x_y] = new long[m_LatticeSize];
		}
	}
}

/**
 *@brief CreateBlockTable()Ő̈jB
 */
void BlockMatching::DeleteBlockTable()
{
	for(int cnt_z = 0; cnt_z < ANGLE_MAX ; cnt_z++){
		for(int cnt_x_y = 0; cnt_x_y < m_LatticeSize; cnt_x_y++){
			delete[] m_BlockTable[cnt_z][cnt_x_y];
		}
		delete[] m_BlockTable[cnt_z];
	}
	delete[] m_BlockTable;
	m_BlockTable = 0;
}

/**
 * @brief }bvǐՂsB
 * @param CeilingMap }b`Osx[X摜ւ̎Q
 * @param CurImage ݂̃C[Wւ̎Q
 *
 */
void BlockMatching::MapTracking(CeilingMap &CeilingMap, ImageData &CurImage)
{
	ImageData		capImage;
	SignedOdometry_st	odometry;
#ifdef _USE_SHOW_MAP
	int				x,		y;
#endif
	static int reach = 0; //}b`O̒T͈͂𒲐p[^Ǝv邪Ƃ肠sgp

	/* }bv}b`O */
	/* }b`Oɂ́ALv`摜1/4XP[ɏk߂Kv */
	capImage = CurImage.PyrDown();

	odometry = Matching(CeilingMap, capImage, reach);
	CeilingMap.IncrementOdometry(odometry);

#ifdef _USE_SHOW_MAP
	ImageData		PackImage;
	PackImage.CreateImage(m_LatticeSize, m_LatticeSize);
	Packing(capImage, PackImage, 0/*CeilingMap.GetTheta()*/);//ŉ摜]Ă

	for (y = 0; y < m_LatticeSize; y++) {
		for (x = 0; x < m_LatticeSize; x++) {
			rstat->buf[x+y*m_LatticeSize] = (PackImage[x+y*m_LatticeSize]);
		}
	}  
	rstat->x = CeilingMap.GetPosX();
	rstat->y = CeilingMap.GetPosY();
	rstat->r = CeilingMap.GetTheta();
#endif
}

/**
 *@brief 摜}b`OsB
 *@param CeilingMap }b`Osx[X摜ւ̎Q
 *@param CurImage ݉摜ւ̎Q
 *@param reach }b`O͈͕␳l
 */
SignedOdometry_st BlockMatching::Matching(CeilingMap &CeilingMap, ImageData &CurImage, int reach)
{
	SignedOdometry_st	result;
	ImageData		PackImage;
	int				min;
	int				i,		s;
	int				x,		y;

	result.m_x = 0;
	result.m_y = 0;
	result.m_theta = 0.0;

	PackImage.CreateImage(m_LatticeSize, m_LatticeSize);
	Packing(CurImage, PackImage, CeilingMap.GetTheta());

	// ]l߂ĂEEË݂ʒuǂlT
	min = SumOfAbsoluteDifference(CeilingMap, PackImage, CeilingMap.GetPosX(), CeilingMap.GetPosY());

	//pxT }m_Resolution * SEARCH_RANGE
	for ( i = -(SEARCH_RANGE + reach); i <= (SEARCH_RANGE + reach); i++) { 

		Packing(CurImage, PackImage, CeilingMap.GetTheta() + (double)( i * M_PI / m_Resolution ));
		//XT }SEARCH_RANGE
		for ( x = -(SEARCH_RANGE + reach); x <= (SEARCH_RANGE + reach); x++) {

			//YT }SEARCH_RANGE
			for ( y = -(SEARCH_RANGE + reach); y <= (SEARCH_RANGE + reach); y++) {
				s = SumOfAbsoluteDifference(CeilingMap, PackImage,  CeilingMap.GetPosX() + x, CeilingMap.GetPosY() + y);

				if (s < min) {
					//ݒn̍XV
					min = s;
					result.m_x = x;
					result.m_y = y;
					result.m_theta = i;
				}
			}
		}
	}
	result.m_theta = result.m_theta * M_PI / m_Resolution;

	return result;
}


/**
 *@brief		Px̑a(SAD; Sum of Absolute Difference)vZ
 *@attention	r(Wł)64~64ōŝŁA摜f[^64~64ɂĂKv
 *@note			2̉摜̓W_̍ώZB
 *@param		src }b`Osx[X摜̎Q
 *@param		data 64~64kς݌݉摜̎Q
 *@param		increment_x x[X摜_̃ItZbg
 *@param		increment_y x[X摜_̃ItZbg
 */
int BlockMatching::SumOfAbsoluteDifference(ImageData &src, ImageData &data, unsigned long offset_x, unsigned long offset_y)
{
	int cell_x, cell_y;
	int result, diff;

	result = 0;
	for( cell_y = 0; cell_y < m_LatticeSize; cell_y++) {
		for( cell_x = 0; cell_x < m_LatticeSize; cell_x++) {
			diff = src(cell_x + offset_x, cell_y + offset_y) - data(cell_x, cell_y);
			if ( diff < 0)
				result -= diff;
		}
	}
	return result;
}

/**
 *@brief 摜64~64ɏk
 *@param org k摜̎Q



 *@param packData 64~64kf[^i[̎Q
 *@param theta 摜̉]px
 */
void BlockMatching::Packing(ImageData &org, ImageData &packData, double theta)
{
	int x, y;
	int rotation;

	if (theta > M_PI)		/* 180xzĂꍇA}CiXɕύX */
		theta = -M_PI * 2 + theta;
	else if (theta < -M_PI)	/* -180ꍇAvXɕύX */
		theta = M_PI * 2 + theta;

	rotation = (int)(theta / ( M_PI / m_Resolution ) ) + m_Resolution;	/* WA->x ϊ */

	for (x=0; x < m_LatticeSize; x++) {
		for (y=0; y < m_LatticeSize; y++) {
			if (m_BlockTable[rotation][x][y] >= 0 && m_BlockTable[rotation][x][y] < org.GetWidth() * org.GetHeight())
				packData[x+y*m_LatticeSize] = org[m_BlockTable[rotation][x][y]];	/* ]ꍇ̍Wʒuɂf[^o */
			else
				packData[x+y*m_LatticeSize] = 0;

			if (packData[x+y*m_LatticeSize] > m_BlackWhiteValue )	/* 2l臒lsA/ɕύX */
				packData[x+y*m_LatticeSize] = MAX_BRIGHTNESS;
			else
				packData[x+y*m_LatticeSize] = 0;
		}
	}
}
